/*
 * Copyright
 *   2007 axYus - www.axyus.com
 *   2010 C ARIOUAT - assia.ariouat@axyus.com
 *
 * This file is part of XEMELIOS.
 *
 * XEMELIOS is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * XEMELIOS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with XEMELIOS; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package fr.gouv.finances.dgfip.xemelios.controls.sortiesdirectesstock;
import java.util.Hashtable;
import java.util.Stack;
import java.util.Vector;

import org.apache.log4j.Logger;
import org.xml.sax.Attributes;
import org.xml.sax.Locator;
import org.xml.sax.SAXException;

import fr.gouv.finances.cp.xemelios.controls.AbstractUnitControl;
import fr.gouv.finances.cp.xemelios.controls.Anomalie;
import fr.gouv.finances.cp.xemelios.controls.IdGenerator;
import fr.gouv.finances.cp.xemelios.controls.Node;


/**
 * "Si TYPE_ID_FONC est valorisé alors ID_FONC_PROD doit être renseigné.
   Sinon, ID_CHORUS_PROD doit être valorisé"

 * @author Assia ARIOUAT
 */
public class M104 extends AbstractUnitControl {
    public static final String CTRL_ID = "CTL-M104" ;
    public static final transient String RESET_COUNTER_PATH = "FEN0071A/SDS/";
    public static final transient String CHEMIN_ENTETE_IDAE = "FEN0071A/SDS/ENTETE/ID_AE/";
    public static final transient String CHEMIN_TYPE_ID_FONC= "FEN0071A/SDS/POSTE/TYPE_ID_FONC/";
    public static final transient String CHEMIN_ID_FONC_PROD= "FEN0071A/SDS/POSTE/ID_FONC_PROD/";
    public static final transient String CHEMIN_ID_CHORUS_PROD= "FEN0071A/SDS/POSTE/ID_CHORUS_PROD/";
    public static final transient String CHEMIN_ID_LIG= "FEN0071A/SDS/POSTE/ID_LIG/";
    public static final transient String CHEMIN_IDPOSTE= "FEN0071A/SDS/POSTE/ID_AE/";
    public static final transient String CHEMIN_POSTE= "FEN0071A/SDS/POSTE/";
    public static final transient String RETURN_ANOMALIES_PATH = RESET_COUNTER_PATH;

    private static final Logger logger = Logger.getLogger(M104.class);

    // pour stocker tous les paramètres d'execution des controles
    private Hashtable<String,Object> hParams;

    private String ID_SDS = null;
	private String ID_SDS_Unique = "";
    private String  type_id_fonc = "";
    private String idPOSTE = "";
	private String numLigneTexte = "";
	private String poste_Nod = "";
	private String id_fonc_prod = "";
	private String id_chourus_prod = "";
    private String id_lig = "";

    //pour le message d'erreurs
    private static final String MSG_IDPOSTE = "#IDPOSTE#";
    private static final String MSG_ID_LIG = "#ID_LIG#";

    
       
    // pour récupérer le texte des balises
    private Stack<StringBuffer> chars = new Stack<StringBuffer>();

    // pour stocker les anomalies que l'on génère
    Vector<Anomalie> anomalies = null;

    public void endDocument() throws SAXException { }

    public void startElement(String uri, String localName, String qName, Attributes atts, String xpath) throws SAXException {
        if(xpath.equals(RESET_COUNTER_PATH)) {           
            anomalies = new Vector<Anomalie>();
            ID_SDS = "";            
            ID_SDS_Unique = atts.getValue("ano:unique-id");            
        } else if(xpath.equals(CHEMIN_POSTE)) {
        	type_id_fonc = id_fonc_prod=  id_chourus_prod="";  
        	idPOSTE=id_lig="";
        	

        	poste_Nod = atts.getValue("ano:node-id");}
        	        	       
        chars.push(new StringBuffer());
    }

    public Vector<Anomalie> endElement(String uri, String localName, String qName, String xpath) throws SAXException {
    	
    		if(xpath.equals(CHEMIN_ENTETE_IDAE)) {
    			ID_SDS = chars.peek().toString();
    			}
    		if(xpath.equals(CHEMIN_ID_LIG)) {
    			id_lig = chars.peek().toString();
    			}
    		else if (xpath.equals(CHEMIN_IDPOSTE)){
    			idPOSTE=chars.peek().toString();
    			}
    		 else if(xpath.equals(CHEMIN_TYPE_ID_FONC)) {
    			 
    			 type_id_fonc=chars.peek().toString();
    			
    			 }
    		
    		 else if(xpath.equals(CHEMIN_ID_FONC_PROD)){
    			 id_fonc_prod= chars.peek().toString();
    			 
    		      }
    		 else if(xpath.equals(CHEMIN_ID_CHORUS_PROD)){
    			 id_chourus_prod= chars.peek().toString();
    			

    		      }
    		   		
    		else if(xpath.equals(CHEMIN_POSTE)){
	          
    		  if((!(type_id_fonc.length()==0) && (id_fonc_prod.length()==0 ))||((type_id_fonc.length()==0)&&(id_chourus_prod.length()==0 ))){       	
        	
	        			String anoId = IdGenerator.nextId();
	                    Hashtable<String, Object> xslParams = new Hashtable<String, Object>();
	                    xslParams.put("anoId", anoId);
	                    xslParams.put("presentation","src");
	                    String libelleLien = "SDS_ID "+ID_SDS;
	                    String path = "@ano:unique-id='" + ID_SDS_Unique + "'";
	                    // on reconstitue le message
	                    String msg = (numLigneTexte.length()>0?"Ligne n°"+numLigneTexte+" : ":"");
	        			msg += getDocumentModel().getControlById(CTRL_ID).getMessage().getHtmlContent();
	        			msg = msg.replace("#SDS_ID#", ID_SDS);
	                    msg = msg.replaceAll(MSG_IDPOSTE, idPOSTE);
	                    msg = msg.replaceAll(MSG_ID_LIG, id_lig);
	                          
	                    Anomalie ano = new Anomalie(anoId,
	                            getDocumentModel().getControlById(CTRL_ID),
	                            getDocumentModel().getDocumentId(),
	                            "FEN0071A",
	                            "SDS",
	                            ID_SDS,
	                            localName,  // l'élément en anomalie est bien SDS
	                            libelleLien,
	                            msg,
	                            getDocumentModel().getControlById(CTRL_ID).getRegle().getHtmlContent(),
	                            getDocumentModel().getControlById(CTRL_ID).getSeverity(),
	                            path,
	                            xslParams);
	                    ano.addNode(new Node(poste_Nod));
	                    anomalies.add(ano);
    				}
		            chars.pop();
		            return null;
		            }
         else if(xpath.equals(RETURN_ANOMALIES_PATH)){
        	chars.pop();
            return anomalies;
        }
        chars.pop();
        return null;
    }

    public void characters(char[] ch, int start, int length, String xpath) throws SAXException {
        // on met les caractères lus dans la pile
        chars.peek().append(ch, start, length);
    }

    public void ignorableWhitespace(char[] ch, int start, int length, String xpath) throws SAXException { }

    public void processingInstruction(String target, String data, String xpath) throws SAXException { }

    public void skippedEntity(String name, String xpath) throws SAXException { }

    public void setParameters(Hashtable<String, Object> params) {
        this.hParams=params;
    }

    public void setDocumentLocator(Locator locator) { }

    public void startDocument() throws SAXException { }

    public void startPrefixMapping(String prefix, String uri, String xpath) throws SAXException { }

    public void endPrefixMapping(String prefix, String xpath) throws SAXException { }
}
